Lattice Builder Manual Software Package for Constructing Rank-1 Lattices

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Friends Modules Pages
Public Types | Public Member Functions | Static Public Member Functions | List of all members
LatBuilder::ProjDepMerit::Spectral< NORM > Class Template Reference

Figure of merit based on the spectral test. More...

`#include <Spectral.h>`

Inherits LatBuilder::ProjDepMerit::Base< Spectral< NORM > >.

## Public Types
typedef NORM | Normalizer

## Public Member Functions
| Spectral (Real power=1.0)
| Constructor. More...
bool | symmetric () const
Real | power () const
| Returns the power parameter.
std::string | name () const
template<LatType LAT, Compress COMPRESS>
Evaluator< Spectral, LAT, COMPRESS > | evaluator (Storage< LAT, COMPRESS > storage) const
| Creates an evaluator for the projection-dependent figure of merit.
Public Member Functions inherited from LatBuilder::ProjDepMerit::Base< Spectral< NORM > >
Storage< LAT, COMPRESS > ::MeritValue | operator() (const Storage< LAT, COMPRESS > &storage, const LatDef< LAT > &lat, const LatCommon::Coordinates &projection) const
| Computes the value of the figure of merit of lattice `lat` for projection `projection`.
std::string | name () const
| Returns the name of the figure of merit.
bool | symmetric () const
| Returns `true` if the value of the figure of merit is invariant under a reflection of the generating vector \(\boldsymbol a=(a_1, \dots, a_s)\) along any axis such that \(a_j \mapsto n - a_j\), where \(n\) is the number of points in the lattice point set.
Evaluator< Spectral< NORM > , LAT, COMPRESS > | evaluator (const Storage< LAT, COMPRESS > &storage) const
| Creates an evaluator for the projection-dependent figure of merit.
Spectral< NORM > & | derived ()
const Spectral< NORM > & | derived () const

## Static Public Member Functions
static constexpr Compress | suggestedCompression ()

## Detailed Description

### template<class NORM>
class LatBuilder::ProjDepMerit::Spectral< NORM >

Figure of merit based on the spectral test.

Implements the computation of the inverse length of the shortest dual vector in a lattice.

The value of the figure of merit is the normalized inverse length of the shortest dual vector, raised to a user-specified power.

Template Parameters

  NORM | Normalizer type.

Examples:
  tutorial/MeritSeqCBC.cc, tutorial/MeritSeqCBCSignals.cc, tutorial/WeightedFigureOfMerit.cc, tutorial/WeightedFigureOfMeritCBC.cc, and tutorial/WeightedFigureOfMeritSignals.cc.

## Constructor & Destructor Documentation

template<class NORM >

LatBuilder::ProjDepMerit::Spectral< NORM >::Spectral | ( | Real | power = `1.0` | ) |
| inline

Constructor.

Parameters

  power | Exponent to which the contribution for each contribution is raised.

The documentation for this class was generated from the following file:

- latbuilder/include/latbuilder/ProjDepMerit/Spectral.h